"""Typechecking property class"""
import types
import Numeric
from Kplot import Matrix, Color

knowntypes = {Numeric.ArrayType:"Numeric Array", types.FloatType:"float", types.IntType:"int", Matrix:"Matrix", Color:"Color", types.StringType:"string"}
def formattypelist(typelist):
	s = ""
	for t in typelist:
		if type(t) == types.TupleType:
			s += "(" +formattypelist(t) +")"
		else:
			if t in knowntypes:
				s += ""+knowntypes[t]+"" +", "
			else:
				s += str(t)


	#print "!!!!", s[-2:]
	if s[-2:] == ", ":
		return s[:-2]
	else:
		return s

class ReprWrapper:
	def __init__(self, obj):
		self.obj = obj

	def __repr__(self):
		return str(self.obj)

class autoproperty(object):
	def __init__(self, typelist=None, default=None, docstring=None):
		self.values = {}
		#print typelist
		self.typelist = typelist
		self.default = default
		if default != None and typelist != None:
			if not self.__typecheck(default, self.typelist) and not callable(default):
				raise Exception, "default should be of type: " +str(self.typelist) +" not: " +str(type(default))
		self.__doc__ = "attribute\n"
		
		self.__doc__ = ""
		if docstring != None:
			self.__doc__ += docstring
		else:
			self.__doc__ += "no info"

		self.__doc__ += "\ndefault: "
		if default != None:
			self.__doc__ += repr(default)
		else:
			self.__doc__ += "no default"

		self.__doc__ += "\nallowed types: "
		if typelist != None:
			self.__doc__ += formattypelist(typelist)
			pass
		else:
			self.__doc__ += "any type"


	def __get__(self, obj, cls):

		if obj == None: # pydoc is extracting it's value
			return ReprWrapper("attribute")
		if not self.values.has_key(obj):
			if callable(self.default):
				default = self.default()
			else:
				default = self.default
			self.values[obj] = default
		return self.values[obj]

	def __set__(self, obj, value):
		if (self.typelist == None) or (value == None) or (self.__typecheck(value, self.typelist)):
			self.values[obj] = value
			obj.changeNotify()
		else:
			name = obj.getAttrName(self)
			raise TypeError, "wrong type for '" +name +"': " +str(type(value)) +" allowed types: " +str(self.typelist)

	def __typecheck(self, value, typelist):
		tl = self.__totypelist(value)
		#print "1)",tl, "\n", "2)", self.typelist
		for t in typelist:
			if self.equals(tl, t):
				return 1
		return 0

	def equals(self, left, right):
		metatypeleft = type(left)
		metatyperight = type(right)
		sequencelist = [types.TupleType, types.ListType]
		#print "@!", metatypeleft, metatyperight
		if metatyperight in sequencelist:
			if metatypeleft != metatyperight or len(left) != len(right):
				return 0
			else:
				for i in range(0, len(left)):
					if not self.equals(left[i], right[i]):
						return 0
				return 1
		elif right in sequencelist:
			#print "wheeee",
			return type(left) == right
		else:
			#print left, right
			#if type(right) == types.InstanceType:
			#	return right == left
			#else:
			#print "!",left, right
			if type(right) == types.ClassType:
				return issubclass(left, right)
			else:
				return left == right


	def __totypelist(self, value):
		valuetype = type(value)
		if valuetype == types.ListType:
			typelist = []
			[typelist.append(self.__totypelist(t)) for t in value]
			#print "TL", typelist
			return typelist
		elif valuetype == types.TupleType:
			typelist = ()
			for t in value:
				typelist += (self.__totypelist(t),)
			return typelist
		else:
			#print "->>>", type(value)
			#if type(value) != types.TypeType:
			#print "->>>", type(value)

			if type(value) == types.InstanceType:
			#if type(value) == types.ClassType:
				return value.__class__
			else:
				return type(value)


class functionautoproperty(autoproperty):
	def __init__(self, typelist=None, default=None, docstring=None):
		autoproperty.__init__(self, typelist, default, docstring)

	def __get__(self, obj, cls):

		if obj == None: # pydoc is extracting it's value
			return ReprWrapper("attribute")
		if not self.values.has_key(obj):
			default = self.default
			self.values[obj] = default
		return self.values[obj]
