from plotobject import PlotObject
from properties import *
from autoproperty import *

class Lines(PlotObject):
	color = colorproperty()
	linestyle = linestyleproperty()
	linewidth = linewidthproperty()
	x = arrayproperty()
	y = arrayproperty()
	matrix = matrixproperty()
	units = stringproperty()

	def __init__(self, x, y, defaults=None,**properties):
		PlotObject.__init__(self, defaults=defaults, properties=properties)
		self.x = x
		self.y = y

	def plot(self, dev):
		dev.pushWorldMatrix(self.matrix)
		dev.plotLines(self.x, self.y, color=self.color, linestyle=self.linestyle, linewidth=self.linewidth, units=self.units)
		dev.popWorldMatrix()
