"""shapes for the Kplot.plotobjects.Marker(s) plottable objects

These shapes can be used with the Marker(s) class in the Kplot.plotobjects package.
The predefined shapes are made using the Kplot.points.Point class.

plus - a plus shape
x - an x shape
star - a shape like the seastar, 5 arms
solidstart - like star, but solid
tristar - a star with 3 points, like the mercedes symbol, has no interior
square - a simple square
solidsquare - like square, but solid
circle - not a real circle, but a fine polygon
solidcircle - like circle, but solid

use it like:
	import Kplot
	p = Kplot.Marker((10, 15), Kplot.points.tristart)
see Kplot.plotobjects.nonbasic.Marker
"""
from point import Point
import math

plus = Point(4, 0.5, 0, 90 * math.pi/180, "normal", "nofill")
x = Point(4, 0.5, 0, 45 * math.pi/180, "normal", "nofill")

star = Point(5, 0.5, 0.2, 90 * math.pi/180, "normal", "nofill")
solidstar = Point(5, 0.5, 0.2, 90 * math.pi/180, "noline", "solid")

tristar = Point(3, 0.5, 0, 90 * math.pi/180, "normal", "nofill")

square = Point(2, 0.5, 0.5, 45 * math.pi/180, "normal", "nofill")
solidsquare = Point(2, 0.5, 0.5, 45 * math.pi/180, "noline", "solid")

circle = Point(12, 0.5, 0.5, 45 * math.pi/180, "normal", "nofill")
solidcircle = Point(12, 0.5, 0.5, 45 * math.pi/180, "noline", "solid")


