from Numeric import *
import Kplot
from math import *

class Point:
	def __init__(self, count, evenradius, oddradius, startangle, linestyle, fillstyle):
		self.count = count
		self.evenradius = float(evenradius)
		self.oddradius = float(oddradius)
		self.startangle = startangle
		self.linestyle = linestyle
		self.fillstyle = fillstyle

	def plot(self, dev, location, color, linewidth, units, pointsize, fillstyle=None, linestyle=None):
		if fillstyle!=None:
			self.fillstyle = fillstyle
		if linestyle!=None:
			self.linestyle = linestyle
		location = Kplot.Vector(location)
		pointsize = float(pointsize)
		x = []
		y = []
		scale = dev.getUnitMatrix(units) * dev.getViewportMatrix().inverse() * dev.getWorldMatrix().inverse()
		scale[0,2] = 0 
		scale[1,2] = 0 
		vec = Kplot.Vector(0,0)
		for i in range(self.count*2):
			angle = (i * pi*2) / (self.count*2)  + self.startangle
			if (i % 2) == 0: # even
				vec.x = cos(angle) * self.evenradius * pointsize
				vec.y = sin(angle) * self.evenradius * pointsize
			else: # odd
				vec.x = cos(angle) * self.oddradius * pointsize
				vec.y = sin(angle) * self.oddradius * pointsize
			vec = scale * vec
			x.append(location.x + vec.x)
			y.append(location.y + vec.y)
		dev.plotPolygon(x, y, color=color, linestyle=self.linestyle, fillstyle=self.fillstyle, linewidth=linewidth, units=units)
		#x.append(x[0])
		#y.append(y[0])
		#dev.plotPolyline(x, y, color=color, linestyle="normal", linewidth=linewidth, units=units)



