import types
import Kplot
import Numeric
import os
from psbasedevice import PsBaseDevice

class FileDevice(PsBaseDevice):
	def __init__(self, filename=None, size=(200, 200), units=None):
		if filename == None:
			self.filename = "Kplot.ps"
		else:
			self.filename = filename + ".ps"
		PsBaseDevice.__init__(self, size=size, units=units)

	def open(self):
		PsBaseDevice.open(self)
		#self.outpipe, self.inpipe = os.popen2("gs -dNOPAUSE -r%i -g%ix%i -" % (self.dpi, self.res.x, self.res.y))
		self.outpipe = file(self.filename, "w")
		self.outputHeader()
		self.outputHeaderCode()
		self.setDimensions()


	def write(self, code):
		try:
			self.outpipe.write(code)
		except:
			print self.inpipe.read()
			raise

	def writeln(self, code):
		#print code
		try:
			self.outpipe.write(code+"\n")
		except:
			print self.inpipe.read()
			raise
		#print code

	def flush(self):
		try:
			self.outpipe.flush()
		except:
			print self.inpipe.read()
			raise

	def outputFooter(self):
		PsBaseDevice.outputFooter(self)
		self.write("showpage\n")

	def clear(self):
		#self.writeln("showpage");
		if self.outpipe.tell() > 0:
			self.outpipe.truncate(0)
		self.outpipe.seek(0)
		PsBaseDevice.clear(self)
		self.flush();

	def close(self):
		self.outpipe.flush()
