import Kplot

class Panel(Kplot.Panel):
	def __init__(self, p1, p2, parent=None):
		Kplot.Panel.__init__(self, p1=p1, p2=p2, parent=parent)

	def pushReverseClipPath(self, dev):
		dev.pushViewportMatrix(self.viewportmatrix)
		dev.pushReverseClipPath()
		clippingchildren = [child for child in self.childs if child.clipparent]
		for child in clippingchildren:
			child.pushReverseClipPath(dev)
		dev.popViewportMatrix()

	def popClipPath(self, dev):
		dev.popClipPath()
		clippingchildren = [child for child in self.childs if child.clipparent]
		for child in clippingchildren:
			child.popClipPath(dev)

	def plot(self, dev):
		clippingchildren = [child for child in self.childs if child.clipparent]
		nonclippingchildren = [child for child in self.childs if not child.clipparent]


		dev.pushViewportMatrix(self.viewportmatrix)

		for child in clippingchildren:
			child.pushReverseClipPath(dev)

		if self.clipping:
			dev.pushClipPath()

		dev.pushWorldMatrix(self.worldmatrix)
		dev.transformation = Kplot.NoTransformation()
		p1 = self.worldmatrix.inverse() * (0, 0)
		p2 = self.worldmatrix.inverse() * (1, 1)
		rect = Kplot.Rectangle(p1, p2, color=self.color, fillstyle=self.fillstyle, linestyle="noline", linewidth=0)
		rect.plot(dev)
		dev.transformation = self.transformation
		for o in self.objects:
			o.plot(dev)
		dev.popWorldMatrix()

		if self.clipping:
			dev.popClipPath()

		for child in clippingchildren:
			child.popClipPath(dev)

		if self.clipping:
			dev.pushClipPath()


		if not self.clipchildren and self.clipping:
			dev.popClipPath()

		for child in self.childs:
			child.plot(dev)

		if self.clipchildren and self.clipping:
			dev.popClipPath()


		dev.popViewportMatrix()
