import Kplot
from Kplot.tools import issequence

class Image(object):
	def __init__(self, data, colormap=None):
		if (not issequence(data)) or (not issequence(data[0])):
			raise Exception, "data should be a 2 dimensional array"

		self.data = data
		self.image = Kplot.Image(data, colormap=colormap)
		self.box = Kplot.Box()

		self.device = Kplot.createDevice()
		self.device.setAutoReplot(False)
		self.panel = self.device.createPanel()
		self.overlay = self.panel.overlay(p1=(-2,-2),p2=(2,2))

		self.panel.add(self.image)
		self.overlay.add(self.box)

		self.setWorld()
		self.device.setAutoReplot(True)

	def __del__(self):
		self.device.close()

	def setWorld(self):
		ymargin = 0.0# * (max(self.line.y)-min(self.line.y))
		xmargin = 0.0# * (max(self.line.x)-min(self.line.x))
		self.panel.setWorldImage(self.data, xmargin=xmargin,ymargin=ymargin)
		self.replot()

	def replot(self):
		self.device.output()
