chapter("Additional topics",0)
chapter("Kplot startup script and defaults",1)
text("""When you import Kplot, and the KPLOT_STARTUP environmental variable is
set to a Python script, it gets executed. Here you can configure Kplot, like
setting default values for PlotObjects.
""")

note("""For each property you can set the default, the Box.drawgrid
property is set to False in the next example.
""")

code("""
>>> import Kplot
>>> Kplot.Box.setDefault("drawgrid", False)
>>> g = Kplot.simple.Graph([1,2,3], [3,5,2])
""")

text("""You can put these defaults in the KPLOT_STARTUP script""")
code("""
$ setenv KPLOT_STARTUP ~/.kplotstartup.py
$ echo 'import Kplot; Kplot.Box.setDefault("drawgrid", False)' >> ~/.kplotstartup.py
$ python
>>> import Kplot
>>> g = Kplot.simple.Graph([1,2,3], [3,5,2])
""")


chapter("Contour lines",1)
chapter("Matrices and Vectors",1)
chapter("Coordinate systems and units",1)
