from math import pi
class Shape:
	def area(self):
		pass # do nothing
	def perimeter(self):
		pass # do nothing
	def info(self):
		print "    area:", self.area(), "perimeter:", self.perimeter()

class Rectangle(Shape):
	def __init__(self, width, height): # this will be called when an object is created
		self.width = width
		self.height = height
	def area(self):
		return self.width * self.height
	def perimeter(self):
		return self.width * 2 + self.height * 2

class Circle(Shape):
	def __init__(self, radius):
		self.radius = radius
	def area(self):
		return pi * self.radius ** 2
	def perimeter(self):
		return 2 * pi * self.radius

		
def compare(shape1, shape2):
	if shape1.area() > shape2.area():
		print "shape1's area is larger than shape2"
	elif shape1.area() < shape2.area():
		print "shape2's area is larger than shape1"
	else:
		print "shape1 and shape2 have equal areas"

# create 2 object from the bleuprints (classes)
circle = Circle(1)
rectangle = Rectangle(5,4)

print "circle"
circle.info()
print "rectangle"
rectangle.info()

compare(circle, rectangle)