#!/usr/bin/env python

from document import *
from outputpdf import OutputPDF
import sys
doc = Document()
chapterstack = []
def chapter(title, level):
	while len(chapterstack) > (level):
		chapterstack.pop()
	chapter = Chapter(title, doc, level)

	#print title, len(chapterstack), level
	if level == 0:
		#print "adding to level 0"
		doc.addChapter(chapter)
		chapterstack.append(chapter)
	if len(chapterstack) == (level):
		#print "adding to level ", level
		chapterstack[-1].addChapter(chapter)
		chapterstack.append(chapter)


def text(txt):
	chapterstack[-1].addParagraph(TextParagraph(txt))

def code(txt):
	chapterstack[-1].addParagraph(CodeParagraph(txt))

def comment(txt):
	chapterstack[-1].addParagraph(CommentParagraph(txt))

def image(url, width=None, height=None):
	chapterstack[-1].addParagraph(ImageParagraph(url, width, height))

#chapter("1 Blaat",0)
#chapter("1.1 Blaat",1)
#chapter("1.1.1 Blaat",2)
#chapter("1.2 Blaat",1)
#chapter("2 Blaat",0)
#chapter("2.1 Blaat",1)
#chapter("2.1.1 Blaat",2)
#chapter("3 Blaat",0)
__builtins__.chapter = chapter
__builtins__.text = text
__builtins__.code = code
__builtins__.comment = comment
__builtins__.note = comment
__builtins__.text = text
__builtins__.image = image

import os
os.environ["KPLOT_DEVICE"] = "Kplot.ps.PngDevice"
os.environ["KPLOT_GS_CMDLINE"] = "-dTextAlphaBits=4 -dGraphicsAlphaBits=4"
os.environ["KPLOT_GS_CMDLINE"] = "-dTextAlphaBits=4"
os.environ["KPLOT_SIZE"] = "(150, 100)"

output = OutputPDF("Kplot", [])
__builtins__.output = output
__builtins__.chapterstack = chapterstack
import chapters.chapter1
import chapters.chapter2
import chapters.chapter3
import chapters.chapter4
import chapters.chapter_devices
import chapters.chapter5
import chapters.appendixA
import chapters.appendixB
if "--with-apiref" in sys.argv:
	import chapters.apireference


doc.generate(output)
output.close()

