import Kplot
from Numeric import arange, pi, sin, cos

class Circle(Kplot.PlotObject):
	def __init__(self, center, radius, parts=100):
		self.center = center
		self.radius = radius
		self.parts = parts

	def plot(self, dev):
		sx, sy = self.center
		step = 2 * pi / self.parts
		t = arange(0, 4*pi+step, step) # +step to close the circle
		x = sin(t) * self.radius + sx
		y = cos(t) * self.radius + sy
		dev.plotPolyline(x=x, y=y, color="red", linestyle="normal", linewidth=1)

circle = Circle((0.5, 0.5), 0.4)
dev = Kplot.createDevice()
circle.plot(dev)
dev.close()
