import Kplot
file = open("index.html", "w")
import re
def out(s):
	#s = re.sub("""${VERSION}""", Kplot.version, s)
	s = s.replace("${VERSION}", Kplot.version)
	global file
	file.write(s)

out("""<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
        <title>Kplot ${VERSION}</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <link rel="stylesheet" type="text/css" href="index.css">
</HEAD>
<BODY>
<center>

<br>

<table width="80%" cellspacing=2 cellpadding=4 class="main">
<tr>
        <td class=header>
        Kplot ${VERSION}
        </td>
</tr>
<tr>
        <td width="100%" align=left class="main">
		To check what version of Kplot you have, run python, import Kplot, and print out Kplot.version
<pre>
$ python
>>> import Kplot
>>> Kplot.version
'${VERSION}'
</pre>
		If you get an error, you must have Kplot-0.1. <p>
        </td>
</tr>
</table>

<br>

<table width="80%" cellspacing=2 cellpadding=4 class="main">
<tr>
        <td class=header>
        Documentation
        </td>
</tr>
<tr>
        <td width="100%" align=left class="main">
		<ul>
		<li><a href="Kplot-${VERSION}.pdf">Tutorial(pdf): Kplot-${VERSION}.pdf</a><br>
		<!-- <li><a href="Kplot-${VERSION}_with_apiref.pdf">Tutorial(pdf) + API ref: Kplot-${VERSION}_with_apiref.pdf</a><br>
		-->
		<li><a href="kdoc/">API documentation(html)</a><br>
		</ul>
		</td>
</tr>
</table>

<br>

<table width="80%" cellspacing=2 cellpadding=4 class="main">
<tr>
        <td class=header>
        Requirements
        </td>
</tr>
<tr>
        <td width="100%" align=left class="main">
		<ul>
		<li>Python2.2 <a href="http://www.python.org/">www.python.org</a>
		<li>Numpy(aka Numeric) for Python <a href="http://www.numpy.org/">http://www.numpy.org/</a>
		<li>At least one of the following programs/libraries to get output on your screen:
			<ul>
			<li><a href="http://www.astro.caltech.edu/~tjp/pgplot/">PGPLOT</a>
				and
				<a href="http://www.astro.rug.nl/~breddels/python/ppgplot/">ppgplot</a>
				(a Python binding to PGPLOT). PGPLOT doesn't run on Windows.<br>
			<li>Ghostscript <a href="http://www.ghostscript.com/">http://www.ghostscript.com/</a>.
				Make sure the 'gs' executable is in your PATH
				(test this by running 'gs' from command line).
				Otherwise set the environmental variable GS_BINARY to it.
				In Windows this is the 'gswin32c.exe' executable.<br>
				</i>set GS_BINARY=c:\\gs\\gs7.04\\bin\\gswin32c.exe</i>
			</ul>
		</ul>

		</td>
</tr>
</table>

<br>

<table width="80%" cellspacing=2 cellpadding=4 class="main">
<tr>
        <td class=header>
        Getting and installing Kplot
        </td>
</tr>
<tr>
        <td width="100%" align=left class="main">
		Kplot ${VERSION}:<br>
		<ul>
		<li>
			From source:<br>
			download
			<a href="http://www.astro.rug.nl/~kplot/Kplot-${VERSION}/Kplot-${VERSION}.tar.gz">
			Kplot-${VERSION}.tar.gz
			</a>,
			run 'tar zxfv Kplot-${VERSION}.tar.gz' to
			unpack it, enter the dir and run 'python setup.py install'
		<li>
			Win32 installer:<br>
			download
			<a href="http://www.astro.rug.nl/~kplot/Kplot-${VERSION}/Kplot-${VERSION}.win32.exe">
			Kplot-${VERSION}.win32.exe</a>
			and run.
		<li>
			from CVS:<br>
			First, login, there is no password, just hit enter.<br>
			$ cvs -d :pserver:guest@cvshost.astro.rug.nl:/cvs login<br>
			$ cvs -d :pserver:guest@cvshost.astro.rug.nl:/cvs checkout -r BETA_0_2 Kplot<br>
			Then you can install it, by running 'python setup.py install'
		</ul>
		</td>
</tr>
<tr>
		<td width="100%" align=left class="main">
		Older versions:<br>
		<ul>
		<li><a href="../Kplot-0.1">Kplot-0.1</a>
		</ul>
		</td>

</tr>
</table>

<br>

<table width="80%" cellspacing=2 cellpadding=4 class="main">
<tr>
        <td class=header>
        Kplot ${VERSION} Changes
        </td>
</tr>
<tr>
        <td width="100%" align=left class="main">
		There are some name changes in Kplot-${VERSION}.
<pre>
	Kplot.makeDevice -> Kplot.createDevice
	Kplot.Device.getPanel -> Kplot.Device.createPanel
	Kplot.makeHardcopyDevice -> Kplot.createHardcopyDevice
	Kplot.Point -> Kplot.Marker
	Kplot.Points -> Kplot.Markers
	Kplot.points(package) -> Kplot.markertype
	Kplot.Scatter -> Kplot.MarkerLine
</pre>
<p>
Normally, in Kplot-0.1, you would call 'dev.output()' after a change in a PlotObject.
Now a change in a PlotObject is catched, and the 'dev.output()' will be called automagicly.

        </td>
</tr>



</center>
""")
