#!/usr/bin/env python

import Kplot
import fitsio
import sys

if len(sys.argv) < 2:
	print "expected fits file as first argument"
	sys.exit(-1)

data = fitsio.read_data(sys.argv[1])
header = fitsio.read_keys(sys.argv[1], ["OBJECT", "TELESCOP"])
object, comment = header["OBJECT"]
telescope, comment = header["TELESCOP"]
labeltext = "object %s from %s" % (object.strip(), telescope.strip())

image = Kplot.Image(data, colormap=Kplot.ColorMap.blackwhite)
wedge = Kplot.Wedge(image, "up")
label = Kplot.Label(labeltext, "top")
p1 = (0.5, 0.5)
p2 = (image.getWidth() + 0.5, image.getHeight() + 0.5)

dev = Kplot.makeDevice()
panel = dev.getPanel()
wedgepanel , imagepanel = panel.split(0.2, "vertical")

imagepanel.setWorld(p1, p2)
imagepanel.add(image)
wedgepanel.add(wedge)
panel.add(label)

dev.output()
dev.close()





