#!/usr/bin/env python

import Kplot
import TableIO
import sys

if len(sys.argv) < 2:
	print "expected ascii file as first argument"
	sys.exit(-1)

x, y = TableIO.readColumns(sys.argv[1], "#!")

scatter = Kplot.Scatter(x, y, Kplot.points.tristar)
box = Kplot.Box()
xlabel = Kplot.Label("x", "bottom", displacement=20)
ylabel = Kplot.Label("y", "left", displacement=20)
xlabel.text.fontsize = 20
ylabel.text.fontsize = 20

p1 = (min(x), min(y))
p2 = (max(x), max(y))

dev = Kplot.makeDevice()
panel = dev.getPanel()
panel.setWorld(p1=p1, p2=p2)
panel.add(box, scatter, xlabel, ylabel)

dev.output()
dev.close()
