#!/usr/bin/env python

from Kplot import *
from os import system
import inspect
from Kplot.tools import stripsource
body = ""
classes = []

def example2html(cls):
	global body
	global classes
	if hasattr(cls, "example"):
		s = stripsource(inspect.getsource(cls.example))


	#s = system("python -c 'import Kplot; Kplot." +cls.__name__+".examplesource()'")
	#s = s.split("\n")[1:].join()
	classes.append(cls)

	name = "Kplot." +cls.__name__
	body += """
<hr><a name="%s">example: %s</a><p>
<table cellpadding=5 cellspacing=1 border=1 width="100%%"  class="code">
        <tr>
        <td width="100%%" class=code>
        <pre>%s</pre>
        </td>
        </tr>
</table>
""" % ("example_" +name, name, s)


example2html(Polyline)
example2html(Polygon)
example2html(Text)
example2html(Image)

#(non basic)
example2html(Line)
example2html(Marker)
example2html(Markers)
example2html(Rectangle)

#(compound)
example2html(Scatter)

#(complex)
example2html(Histogram)
example2html(Arrow)
example2html(Wedge)
example2html(Axis)
example2html(Box)
example2html(Grid)

 
s = ""
s += """<div class=title>Appendix C. Examples</div><hr>
All these example can be be run and printed from the Python console.<br>

<table cellpadding=5 cellspacing=1 border=1 width="100%%"  class="code">
        <tr>
        <td width="100%%" class=code>
        <pre>ishi@~> python
Python 2.2.1 (#1, Apr 11 2002, 15:27:15)
[GCC 2.95.3 20010315 (release)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> import Kplot
>>> Kplot.Polygon.examplesource()
import Kplot

print "Polygon example"

x = [1, 4, 4, 1]
y = [1, 1, 4, 4]
polygon = Kplot.Polygon(x, y, fillstyle="crosshatched", color="blue")

dev = Kplot.createDevice()
panel = dev.createPanel()
panel.add(polygon)
panel.setWorld(p1=(0, 0), p2=(5, 5))
dev.output()
dev.close()
>>> Kplot.Polygon.example()
Polygon example
 Type &lt;RETURN&gt; for next page:
>>>
		</pre>
        </td>
        </tr>
</table>
"""
s += "<ul>"
for cls in classes:
	name = "Kplot." +cls.__name__
	s += """<li><a href="#%s">%s</a><br>""" % ("example_" +name, name)
s += "</ul>"
body = s + body


print """
<html>
<head>
	<title>Kplot examples</title>
	<link rel="stylesheet" type="text/css" href="documentation.css">
</head>
<body>
%s
</body>
</html>
""" % body

#(experimental)
#TAxis.examplesource()
#WcsBox.examplesource()
#WcsGrid.examplesource()
