#!/usr/bin/env python2.2
import unittest
import math
from Kplot import *

class ColorTest(unittest.TestCase):

	def setUp(self):
		self.white = Color(1, 1, 1)
		self.red = Color.red

	def testColors(self):
		self.assertEquals(Color.fromString("white"), self.white)
		self.assertEquals(Color.fromString("red"), self.red)
		self.assertEquals(Color.red, Color(1, 0, 0))


	def testCompare(self):
		self.assertEquals(self.white, Color.white)
		self.assertEquals(self.white, Color.fromString("white"))
		self.assertNotEquals(self.red, Color.fromString("white"))

	def testRGB(self):
		self.assertEquals(self.red.getRGB(), (1.0, 0.0, 0.0))

	def testException(self):
		self.assertRaises(Exception, Color.fromString, "error")

	def testDistance(self):
		self.assert_(math.fabs(Color.fromString("white").distance(Color.fromString("black")) - math.sqrt(3)) < 1e-10)

if __name__ == '__main__':
	unittest.main()



