#!/usr/bin/env python2.2
from Kplot import *
import unittest
import math
from math import *
from plotobject import PlotObjectTest
from Numeric import *

class PolylineTest(PlotObjectTest):
	def testPlot(self):
		polyline = Polyline([1,2,3], [1,2,3])
		polyline.plot(self.dev)
		polyline = Polyline(array([1,2,3]), array([1,2,3]))
		polyline.plot(self.dev)
		polyline = Polyline((1,2,3,4), (1,2,3))
		polyline.plot(self.dev)
		polyline = Polyline((1,2,3), (1,2,3,4))
		polyline.plot(self.dev)

		for linestyle in self.dev.getLinestyles():
			polyline = Polyline((1,2,3), (1,2,3), linestyle=linestyle)
			polyline.plot(self.dev)

class PolygonTest(PlotObjectTest):
	def testPlot(self):
		polygon = Polygon([1,2,3], [1,2,3])
		polygon.plot(self.dev)
		polygon = Polygon(array([1,2,3]), array([1,2,3]))
		polygon.plot(self.dev)
		polygon = Polygon((1,2,3,4), (1,2,3))
		polygon.plot(self.dev)
		polygon = Polygon((1,2,3), (1,2,3,4))
		polygon.plot(self.dev)

		for fillstyle in self.dev.getFillstyles():
			for linestyle in self.dev.getLinestyles():
				polygon = Polygon((1,2,3), (1,2,3), linestyle=linestyle, fillstyle=fillstyle)
				polygon.plot(self.dev)

class TextTest(PlotObjectTest):
	def testPlot(self):
		text = Text("test", (0.5, 0.5))
		text.plot(self.dev)
		text = Text("test", [0.5, 0.5])
		text.plot(self.dev)
		text = Text("test", array([0.5, 0.5]))
		text.plot(self.dev)

		for font in self.dev.getFonts():
			text = Text("test", (0.5, 0.5), font=font)
			text.plot(self.dev)

class ImageTest(PlotObjectTest):
	def testPlot(self):
		image = Image([[1,2,3],[1,2,3]])
		image.plot(self.dev)
		self.assertEquals(image.getWidth(), 3)
		self.assertEquals(image.getHeight(), 2)

		image = Image([[1]], datamin=0.1, datamax=1.1)
		image.plot(self.dev)
		self.assertEquals(image.getWidth(), 1)
		self.assertEquals(image.getHeight(), 1)


if __name__ == '__main__':
	unittest.main()


